base-files: use procd init for urandom_seed
authorEtienne CHAMPETIER <champetier.etienne@gmail.com>
Wed, 20 Jul 2016 12:22:44 +0000 (12:22 +0000)
committerDaniel Golle <daniel@makrotopia.org>
Tue, 26 Jul 2016 23:24:54 +0000 (01:24 +0200)
Previous implementation was blocking the init and
breaking halt/reboot/sysupgrade (reported by Daniel Golle)

v2: use procd logging, use set -e + trap for error handling

Signed-off-by: Etienne CHAMPETIER <champetier.etienne@gmail.com>
Tested-by: Daniel Golle <daniel@makrotopia.org>
package/base-files/files/etc/init.d/urandom_seed
package/base-files/files/sbin/urandom_seed [new file with mode: 0755]

index cb2eb44..17d9c13 100755 (executable)
@@ -1,29 +1,12 @@
 #!/bin/sh /etc/rc.common
 
 START=99
-
-EXTRA_COMMANDS="save"
-
-_log() {
-    logger -t urandom_seed "$1"
-}
-
-_save() {
-    touch $1.tmp || { _log "touch $1 failed"; return; }
-    chown root:root $1.tmp || { _log "chown $1 failed"; return; }
-    chmod 600 $1.tmp || { _log "chmod $1 failed"; return; }
-    getrandom 512 > $1.tmp || { _log "getrandom failed"; return; }
-    mv $1.tmp $1 || { _log "mv $1 failed"; return; }
-}
-
-save() {
-    SEED="$(uci -q get system.@system[0].urandom_seed)"
-    [ "${SEED:0:1}" == "/" ] && _save "$SEED" && _log "Seed saved ($SEED)"
-
-    SEED=/etc/urandom.seed
-    [ ! -f $SEED ] && _save "$SEED" && _log "Seed saved ($SEED)"
-}
-
-boot() {
-    save
+USE_PROCD=1
+
+start_service() {
+    procd_open_instance "urandom_seed"
+    procd_set_param command "/sbin/urandom_seed"
+    procd_set_param stdout 1
+    procd_set_param stderr 1
+    procd_close_instance
 }
diff --git a/package/base-files/files/sbin/urandom_seed b/package/base-files/files/sbin/urandom_seed
new file mode 100755 (executable)
index 0000000..16d3657
--- /dev/null
@@ -0,0 +1,20 @@
+#!/bin/sh
+set -e
+
+trap '[ "$?" -eq 0 ] || echo "An error occured" >&2' EXIT
+
+save() {
+    touch "$1.tmp"
+    chown root:root "$1.tmp"
+    chmod 600 "$1.tmp"
+    getrandom 512 > "$1.tmp"
+    mv "$1.tmp" "$1"
+    echo "Seed saved ($1)"
+}
+
+SEED="$(uci -q get system.@system[0].urandom_seed || true)"
+[ "${SEED:0:1}" == "/" ] && save "$SEED"
+
+SEED=/etc/urandom.seed
+[ ! -f $SEED ] && save "$SEED"
+true